function [] = print_weight(w12, b2, w23, b3, HiddenFunc, OutFunc)
% PRINT_QTABLE : Print Q table.
%
% Syntax : PRINT_QTABLE(Q_table);
%
% Input  : Q_table (Requred) : N x 4 (The number of states x The number of actions)
%
% Output : 
% 
% See also TABLE, DISP, PRINT_ROUTE.
%

    maze_i = 3;
    maze_j = 3;

    a = zeros(4,0);
    %
    % Q Table ̃Xe[g̐JԂD
    % Table 邽߂ɁCActionƂɗicolumnjxNgɕϊ
    fprintf('W12\n');
    disp(w12.');
    fprintf('\n');
    
    fprintf('b2\n');
    disp(b2);
    fprintf('\n');
    
    fprintf('W23\n');
    disp(w23.');
    fprintf('\n');
    
    fprintf('b3\n');
    disp(b3);
    fprintf('\n');
    
    fprintf('Q\n');                         % ۂɍsɎglo
    for current_state_num = 1:maze_i*maze_j
        st = zeros(maze_i*maze_j,1);        % Ԃ One hot ͂̍쐬
        st(current_state_num) = 1;

        X = st;                             % Input (State Number)
    
        z2 = w12.' * X + b2;                % Bw̏dݕtaz2
        if(HiddenFunc == "sigmoid")
            a2 = 1./(1+exp(-z2));           % Bw̏oa2i֐FVOCh֐j
        end

        z3 = w23.' * a2 + b3;               % o͑w̏dݕtaz3
        if(OutFunc == 'Linear')
            a3 = z3;            
        end
    
        a = [a,a3];
        
    end
    disp(a);
end

