 % Q_Learning
% @Q Learningf̃V~[V
%
% gF
%   sw_Q_Learning s
%
% Kvt@CFsw_Q_Learning.m, sw_move_state.m, sw_update_Q.m, print_route.m, print_weight.m
%
% Toolbox : MATLAB 
%
% Tool Version: MATLAB R2018a
% >> [fList,pList] = matlab.codetools.requiredFilesAndProducts('tb_Q_Learning.m');
% >> fList{:}
% >> {pList.Name}'
% ͎s
% >> license('inuse')
%
% see also SW_MOVE_STATE, SW_UPDATE_Q, PRINT_ROUTE, PRINT_WEIGHT.
clear all;
close;

% _V[h1CGs\[h5000C
% őXebv10CV -5 or 5CyieB 5C
% Bw5A=0.001A= 0.9ŃS[

for loop_seed =1:1
rng(loop_seed); % ̃V[hlŒ
%
MaxEpisode = 10000;   % ő̃Gs\[hDThe maximum number of episodes.
Max_t = 10;          % 1Gs\[hł̍ős񐔁CThe maximum number of actions in one episode.
NumHiddenLayer = 5;  % Bw̃m[h̐
%
maze_i = 3;          % HTCYicj
maze_j = 3;          % HTCYij
%
% Ql̕\𐶐(l̓_Ő)
% 9 (3x3) ̏ ~ 4̍siCCCj
% ԉ 0 0 0 0 ƂD
%Q_table = [ rand(8,4) ; 0 0 0 0] ;
% BwCo͑w̕\𐶐
w12 = rand(9,NumHiddenLayer);
b2 = -1*ones(NumHiddenLayer,1);
w23 = rand(NumHiddenLayer,4);
b3 = -1*ones(4,1);
%
%statePɂQl̕ωi[z̍쐬
ax = zeros(1,4);
%
% Reward̕\𐶐(ǂ̓}CiX̕VƂ)
reward_table = [ ...
    0    0     0 ...
    0    -5     0 ...
    -5    -5    10]';
%
% Bẘ֐̐ݒ
HiddenFunc = "sigmoid"; % o͊֐ Sigmoid
% o͊֐̐ݒ
OutFunc = "Linear"; % o͊֐ linear
%
% wKOQ-tableƌoH̕\
% disp("wKOQ-tableƌoH");
% print_weight(w12, b2, w23, b3, HiddenFunc, OutFunc);
% print_route(w12, b2, w23, b3, HiddenFunc, OutFunc);
%
% ͐M쐬
% nCp[p[^̐ݒ :wKC:
alpha = 0.001 ;         % alpha = timeseries([0.001 0.001]');
ganma = 0.9;           % gamma = timeseries([0.9 0.9]');
%
% ʒuiԁj̐ݒFʒu1ijƂ
st = 1;
st1 = 1;


epsilon_tmp = MaxEpisode;

% ȉCQwKsD
tic;                            % Jnȉꍇ́CRgośCRg邱Ɓj
for Episode = 1 : MaxEpisode    % 300i30sځj̊wKƂD
    % Gs\[hƂɖH̊Jn̏ԁiSt = 1jɏ
    st1 = 1;
    % epsilon̒`
    epsilon_tmp = epsilon_tmp - 1;
    epsilon = epsilon_tmp;
    
     fprintf('Episode = %d, Epsilon = %d\n', Episode, epsilon);

    for t=1:Max_t % ő15P゠̍s񐔂Ƃ
        randdata_tmp = uint16(rand*MaxEpisode);
        randdata = randdata_tmp;

        st = st1;                   % ݂̏ԂݒiȌԂɂ鎟̏ԁj
        current_state_num = st;

        % NNōswjp̒liQl̂悤Ȃ́jvZC̏Ԃɂs
        % ̃Xebv̏Ԃo
        [next_state_num, action, Qt] = sw_move_state(w12, b2, w23, b3, ...
                                        HiddenFunc, OutFunc, epsilon, randdata, ...
                                        current_state_num, maze_i, maze_j);     

        
        % sƎ̏Ԃ
        at = action;                        
        st1 = next_state_num;              

        % gOɏoȂ悤ɓꏊɂꍇ̓yieB^
        if st == st1
            penalty = 5;                    
        elseif t == Max_t
            penalty = 5;
        else
            penalty = 0;                
        end
        
        % V𓾂
        % ̂ʒuł̓}CiXij
        reward = reward_table(st1);         
        % EFCg̃Abvf[g
        [w12, b2, w23, b3] = sw_update_Q(st, st1, w12, b2, w23, b3, ...
            HiddenFunc, OutFunc, at, reward, penalty, alpha, ganma, maze_i, maze_j);           
        

        fprintf('Q(%d,%d)->', st, at);
        
        previous_state = st;

        if st1 == 9
             fprintf('S9 Goal\n');
            break;
        end
        %        if(Episode == 1 && t=1)
        %            disp("wKQ-tableƌoH");
        %            print_weight(w12, b2, w23, b3);
        %            print_route(w12, b2, w23, b3, HiddenFunc, OutFunc);
        %        end
    end
     fprintf('\n');
    
%     %statePɂQl̕ωzɊi[
%     st2 = zeros(maze_i*maze_j,1);       % Ԃ One hot ͂̍쐬
%     st2(1) = 1;
% 
%     X = st2;                             % Input (State Number)
%     
%     z2 = w12.' * X + b2; 
%     if(HiddenFunc == "sigmoid")
%         a2 = 1./(1+exp(-z2));           % Bw̏oa3i֐FVOCh֐j
%     end
% 
%     z3 = w23.' * a2 + b3;               % o͑w̏dݕtaz3
%     if(OutFunc == 'Linear')
%         a3 = z3;        
%     end
%         
%     a4 = reshape(a3,1,4);
%         
%     if Episode == 1
%         ax=a4;
%     else
%         ax = [ax;a4];
%     end 
end
toc;

disp("wKQ-tableƌoH");
print_weight(w12, b2, w23, b3, HiddenFunc, OutFunc);
print_route(w12, b2, w23, b3, HiddenFunc, OutFunc);
end
% plot(ax); %state1Ql̕ω̃Ot
